import java.io.*; 
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.net.URL;
import jtp.*;
import jtp.context.owl.*;
import jtp.fol.*;

/** Test for JTP Servlet 
 *  <P>
 *  Taken from Core Servlets and JavaServer Pages
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://www.coreservlets.com/.
 *  &copy; 2000 Marty Hall; may be freely used or adapted.
 */

public class JTPTest extends HttpServlet 
{
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
      throws ServletException, IOException {
    Locale currentLocale = new Locale("el","GR"); 
    response.setLocale(currentLocale);
    
            
	   try 
	  {
	    QueryKB(request,response);
	  }
	  catch(ReasoningException e)
	  { 
	  }

    }
    
    
  public static void QueryKB(HttpServletRequest request,HttpServletResponse response) 
  throws ReasoningException,IOException
  
{
  	
  	String KB_URL = "http://localhost/benefit.owl";
  	String s1,s2,s3,s4,query,a1;
	String familystatus = request.getParameter("familystatus");
	
	OWLReasoningContext owl = new OWLReasoningContext();
	owl.setUp();
	
	owl.loadKB(new URL (KB_URL));
	owl.tellKifString("(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/benefit.owl#|::|TestPerson| |http://localhost/benefit.owl#|::|Person_for_FamilyBenefit|)");
    
    if (familystatus!="none")
    {
    familystatus="|"+familystatus+"|";
	a1="(|http://localhost/benefit.owl#|::|hasFamilyStatus| |http://localhost/benefit.owl#|::|TestPerson| |http://localhost/benefit.owl#|::";
	a1=a1+familystatus+")";
    owl.tellKifString(a1);
    
    };
    
    
     //return comments and classes
     s1="(|http://localhost/benefit.owl#|::|hasDocument| |http://localhost/benefit.owl#|::|TestPerson| ?x)";
	 s2="(|http://www.w3.org/2000/01/rdf-schema#|::|comment| ?x ?comm)";
	 //return Class type
	 s3="(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/benefit.owl#|::|TestPerson|  ?x)";
	 s4="(|http://www.w3.org/2000/01/rdf-schema#|::|subClassOf| ?x |http://localhost/benefit.owl#|::|Person_for_FamilyBenefit| )";
	 
	 query="(and "+s1+s2+")";
	CallReasoner(query,owl,response);
    
  	
  }
  
   public static void CallReasoner(String Query,OWLReasoningContext Owl,HttpServletResponse response)
   throws ReasoningException,IOException
   {
    
    ReasoningStepIterator rsi = Owl.getAskingReasoner().process(Query);
	ReasoningStep rs = null;
	 PrintWriter out = response.getWriter();
    
     out.println("<title>" + "" + "</title>");
     out.println("<center>");
     out.println("<h1>" + " " + "</h1>");
     out.println("<b>");
     
    out.println("<meta http-equiv=\"Content-Type\" content=\"text/html; charset=iso-8859-7\">");
    
	while ((rs = rsi.next()) != null)
	{
		
		if (Query.equals(rs.getGoal()) && rs.getSubProofs().size() == 1)
		{
		    ReasoningStep subRs = (ReasoningStep)rs.getSubProofs().get(0);
		    if (subRs.getGoal() instanceof Literal) 
			rs = subRs; //We are considering the sole child instead of the top-level 
		                    //step (see above)
		}
		
		
		Literal lit = (Literal)rs.getGoal();
		Map bindings = jtp.rs.RSUtils.getRecursiveBindings(rs, null);//Variable bindings
	    for (Iterator it = lit.getArgs().iterator(); it.hasNext();)
		{ //Find the right query variable and extract its value
		    Variable v = (Variable)it.next();
		    if ("x".equals(v.getName()))
			{
			   			}
			if ("comm".equals(v.getName()))
			{
			    out.println("<br>");
			    out.println( bindings.get(v));
			    out.println("<br>");
			   
			}
		}
		
		
	
    }
        out.println("<b>");
        out.println("<center>");
    
    }
    
    public void doPost(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        doGet(request, response);
    }
  
  }
