import java.io.*; 
import javax.servlet.*;
import javax.servlet.http.*;
import java.util.*;
import java.net.URL;
import jtp.*;
import jtp.context.owl.*;
import jtp.fol.*;

/** Test for JTP Servlet 
 *  <P>
 *  Taken from Core Servlets and JavaServer Pages
 *  from Prentice Hall and Sun Microsystems Press,
 *  http://www.coreservlets.com/.
 *  &copy; 2000 Marty Hall; may be freely used or adapted.
 */


public class License extends HttpServlet 
{
  
  public static PrintWriter out;
  public static String X,enteprise,location,power,category,nationality,forest,prox;
  
  public void doGet(HttpServletRequest request,
                    HttpServletResponse response)
      throws ServletException, IOException {
    Locale currentLocale = new Locale("el","GR"); 
    response.setLocale(currentLocale);
     out = response.getWriter();
     out.println("<title>" + "Results" + "</title>");
     out.println("<center>");
     out.println("<h1>" + "Documents needed" + "</h1>");
     out.println("<b>");
    
            
	   try 
	  {
	    QueryKB(request,response);
	  }
	  catch(ReasoningException e)
	  { 
	  }

    }
    
    
  public static void QueryKB(HttpServletRequest request,HttpServletResponse response) 
  throws ReasoningException,IOException
  
{
  	
  	
  	String KB_URL = "http://localhost/license_b.owl";
  	String s1,s2,s3,s4,query,a1;
	String enterprise = request.getParameter("Enterprise");
	String location = request.getParameter("Location");
	String power = request.getParameter("Power");
	String category = request.getParameter("Category");
	String nationality = request.getParameter("Nationality");
	OWLReasoningContext owl = new OWLReasoningContext();
	owl.setUp();
	
	owl.loadKB(new URL (KB_URL));
	
	enterprise="|"+enterprise+"|";
	a1="(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/license_b.owl#|::|TestE| |http://localhost/license_b.owl#|::"+enterprise+")";
    owl.tellKifString(a1);
    
    a1="(|http://localhost/license_b.owl#|::|hasNationality| |http://localhost/license_b.owl#|::|NewPerson| |http://localhost/license_b.owl#|::|"+nationality+"|)";
    owl.tellKifString(a1);
    
    
    owl.tellKifString("(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/license_b.owl#|::|TestC| |http://localhost/license_b.owl#|::|EmployeeCertificate|)");
    owl.tellKifString("(|http://localhost/license_b.owl#|::|hasLicense| |http://localhost/license_b.owl#|::|TestE| |http://localhost/license_b.owl#|::|TestC|)");
   
    owl.tellKifString("(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/license_b.owl#|::|TestP| |http://localhost/license_b.owl#|::|PowerCertificate|)");
    owl.tellKifString("(|http://localhost/license_b.owl#|::|hasLicense| |http://localhost/license_b.owl#|::|TestE| |http://localhost/license_b.owl#|::|TestP|)");
    
    owl.tellKifString("(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/license_b.owl#|::|TestL| |http://localhost/license_b.owl#|::|LocationCertificate|)");
    owl.tellKifString("(|http://localhost/license_b.owl#|::|hasLicense| |http://localhost/license_b.owl#|::|TestE| |http://localhost/license_b.owl#|::|TestL|)");
    
    owl.tellKifString("(|http://www.w3.org/1999/02/22-rdf-syntax-ns#|::type |http://localhost/license_b.owl#|::|Prox| |http://localhost/license_b.owl#|::|ProximityCertificate|)");
    owl.tellKifString("(|http://localhost/license_b.owl#|::|hasLicense| |http://localhost/license_b.owl#|::|TestE| |http://localhost/license_b.owl#|::|Prox|)");
    
    s1="(|http://localhost/license_b.owl#|::|belongsToCategory| |http://localhost/license_b.owl#|::|TestC| ?x)";
    
	query=s1;
	CallReasoner(query,owl,response);
	
	if (X.equals(""))
	{
	 s1="(|http://localhost/license_b.owl#|::|belongsToCategory| |http://localhost/license_b.owl#|::|TestC| |http://localhost/license_b.owl#|::|"+category+"|)";
	 owl.tellKifString(s1);
	 
    }

         
	s2="(|http://localhost/license_b.owl#|::|hasPower| |http://localhost/license_b.owl#|::|TestP| ?x)";
	query=s2;
	CallReasoner(query,owl,response);
	
	if (X.equals(""))
	{
	 s1="(|http://localhost/license_b.owl#|::|hasPower| |http://localhost/license_b.owl#|::|TestP| |http://localhost/license_b.owl#|::|"+power+"|)";
	 owl.tellKifString(s1);
    }
    
    
    s2="(|http://localhost/license_b.owl#|::|LocatedIn| |http://localhost/license_b.owl#|::|TestL| ?x)";
	query=s2;
	CallReasoner(query,owl,response);
	
	if (X.equals(""))
	{
		s1="(|http://localhost/license_b.owl#|::|LocatedIn| |http://localhost/license_b.owl#|::|TestL| |http://localhost/license_b.owl#|::|"+location+"|)";
	    owl.tellKifString(s1);
	  
	}
	
	if (request.getParameter("forest")!=null)
	
	{
		prox="Forest";
	    s1="(|http://localhost/license_b.owl#|::|locatedNear| |http://localhost/license_b.owl#|::|Prox| |http://localhost/license_b.owl#|::|"+prox+"|)";
	    owl.tellKifString(s1);
	 }  	
	
	if (request.getParameter("coast")!=null)
	
	{
		prox="Coast";
	    s1="(|http://localhost/license_b.owl#|::|locatedNear| |http://localhost/license_b.owl#|::|Prox| |http://localhost/license_b.owl#|::|"+prox+"|)";
	    owl.tellKifString(s1);
	 }
	 
	if (request.getParameter("airport")!=null)
	
	{
		prox="CivilAirport";
	    s1="(|http://localhost/license_b.owl#|::|locatedNear| |http://localhost/license_b.owl#|::|Prox| |http://localhost/license_b.owl#|::|"+prox+"|)";
	    owl.tellKifString(s1);
	 }
	 
	 if (request.getParameter("archaeological")!=null)
	
	{
		prox="ArchaeologicalSite";
	    s1="(|http://localhost/license_b.owl#|::|locatedNear| |http://localhost/license_b.owl#|::|Prox| |http://localhost/license_b.owl#|::|"+prox+"|)";
	    owl.tellKifString(s1);
	 }
	  
	s1="(|http://localhost/license_b.owl#|::|hasDocument| |http://localhost/license_b.owl#|::|TestL| ?y)";
	query=s1;
	CallReasoner(query,owl,response);
	s1="(|http://localhost/license_b.owl#|::|hasDocument| |http://localhost/license_b.owl#|::|TestP| ?y)";
	query=s1;
	CallReasoner(query,owl,response);
	s1="(|http://localhost/license_b.owl#|::|hasDocument| |http://localhost/license_b.owl#|::|TestC| ?y)";
	query=s1;
	CallReasoner(query,owl,response);
	s1="(|http://localhost/license_b.owl#|::|hasDocument| |http://localhost/license_b.owl#|::|Prox| ?y)";
	query=s1;
	CallReasoner(query,owl,response);
	s1="(|http://localhost/license_b.owl#|::|hasDocument| |http://localhost/license_b.owl#|::|NewPerson| ?y)";
	query=s1;
	CallReasoner(query,owl,response);
	
    
    
  	
  }
  
  
  
  private static String GetResultString(String str)
    {
     int i,l;
     l=str.length();
     i=str.indexOf('#');
     i=i+5;
     return(str.substring(i,l-1));
       	
    }  
  
   public static void CallReasoner(String Query,OWLReasoningContext Owl,HttpServletResponse response)
   throws ReasoningException,IOException
   {
    
    ReasoningStepIterator rsi = Owl.getAskingReasoner().process(Query);
	ReasoningStep rs = null;
	 
    
     X="";
     
	while ((rs = rsi.next()) != null)
	{
		
		if (Query.equals(rs.getGoal()) && rs.getSubProofs().size() == 1)
		{
		    ReasoningStep subRs = (ReasoningStep)rs.getSubProofs().get(0);
		    if (subRs.getGoal() instanceof Literal) 
			rs = subRs; //We are considering the sole child instead of the top-level 
		                    //step (see above)
		}
		
		
		Literal lit = (Literal)rs.getGoal();
		Map bindings = jtp.rs.RSUtils.getRecursiveBindings(rs, null);//Variable bindings
	    for (Iterator it = lit.getArgs().iterator(); it.hasNext();)
		{ //Find the right query variable and extract its value
		    Variable v = (Variable)it.next();
		    if ("x".equals(v.getName()))
			{
			     
			     X=X.valueOf(bindings.get(v)); 
			}
			if ("y".equals(v.getName()))
			{
			    X=X.valueOf(bindings.get(v)); 
			    X=GetResultString(X);
			    out.println("<br>");
			    out.println(X);
			    out.println("<br>");
			   
			}
		}
		
		
	
    }
        out.println("<b>");
        out.println("<center>");
    
    }
    
    public void doPost(HttpServletRequest request,
                      HttpServletResponse response)
        throws IOException, ServletException
    {
        doGet(request, response);
    }
  
  }
